/**
*	arp.c
*	`qo[`inrhQƃfQwif[^Nwjj
*	Address Resolution Protocol:hoAhXΉl`bAhX
*	Copyright (c)Junnichi Tomaru 2008
*/
#include	"avrntp.h"


/**
*	ARP^C}`FbN
*	PbƂɌĂяoBARPLbVe[ũ^C}Z
*	^CAbv̂͂`qoLbVjB
*	 in	Ȃ
*	out	Ȃ
*/
void	arp_timer( void )
{
	if( arp_cache.timer != 0 ){	/* ^CAbvĂȂ */
		arp_cache.timer--;
		if( arp_cache.timer == 0 ){	/* ^CAbv */
			arp_cache.ipaddr = 0;
		}
	}
}


/**
*	ARPe[u[`
*	MIPAhXAMACAhXB
*	1.IPu[hLXĝƂ́AMACAhXu[hLXgƂ
*	2.IPAhXlbg[NȌꍇ́AQ[gEFCMACAhX
*	3.ȊÓAARPLbVe[u茟B
*	e[uŏɌIPAhXɑ΂MACAhXRs[
*	Ƃ͈MACAhX̓u[hLXgƂAARPvo
*	 in	Ȃ
*	out	0:(܂̓u[hLXg)
*		1:Ȃ(lbg[N)
*		2:Ȃ(lbg[NO)
*/
byte	arp_search( void )
{
	byte	ret, *p;
	dword	adr;

	_di( );		/* 荞݂ōXV̂ŁA֎~Ă猟 */
	ret = 1;
	adr = pacinfo.partipaddr;
	p = pacinfo.mac;
	if( adr == IP_BROADCAST ){	/* u[hLXg */
		memset( p, 0xff, PHYSICALADDR_SIZE );
		_ei( );
		return	0;
	}
	else if(( adr | netmask ) == IP_BROADCAST ){/* lbg[Nu[hLXg */
		memset( p, 0xff, PHYSICALADDR_SIZE );
		_ei( );
		return	0;
	}
	else if(( adr & netmask ) != ( myipaddr & netmask )){
					/* lbg[NÔhoAhX */
		adr = gateway;
		ret = 2;
	}
	if( arp_cache.ipaddr == adr ){	/*  */
		memcpy( p, (byte *)arp_cache.mac, PHYSICALADDR_SIZE );
		ret = 0;
	}
	_ei( );

	return	ret;
}


/**
*	ARPEo^[`
*	ARPLbVAo^ςIPAhXȂ㏑B
*	(IPAhXŋ@BςꍇȂǂɑΉāAɍŐV̏Ԃێ)
*	 in	adr:IPAhX
*		mac:MACAhX
*		cen:o^o^邩
*	out	Ȃ
*/
void	arp_keep( dword adr, byte *mac, swbool cen )
{
	_di( );
	if( arp_cache.ipaddr != adr ){	/* ܂LbVĂȂ */
		if( cen == off ){	/* o^o^Ȃ */
			_ei( );
			return;
		}
	}

	/* IPAhXMACAhX̊֌WLbVe[uɕۊ */
	memcpy((byte *)arp_cache.mac, (byte *)mac, PHYSICALADDR_SIZE );
					/* MACAhX̃Rs[ */
	arp_cache.ipaddr = adr;		/* IPAhX̃Rs[ */
	arp_cache.timer = ARP_TIMEMAX;	/* ARP^C}Zbg */
	_ei( );
}


/**
*	`qov̑M(ꏈȂ̂ŁA֐łׂď)
*	 in	partadr:̂hoAhX
*	out	Ȃ
*/
void	arp_request( dword partadr )
{
	enc_writereg16( ETXST, TMPSTART );/* M擪 */
	enc_writereg16( EWRPT, TMPSTART );/* ݐ擪 */
	enc_writebuf( 0x00 );	/* Format For Per Packet Control Bytes */
				/* MACON3̏Ԃgp */
	enc_fillwrite( 0xff, PHYSICALADDR_SIZE );	/* MACAhX */
	enc_writebuffer( mac_address, PHYSICALADDR_SIZE );	/* MMACAhX */
	enc_writebuf2( ETHERTYPE_ARP );	/* C[Tlbg^Cv */
	enc_writebuf2( ARP_HWETHER );	/* n[hEFA^Cv(C[Tlbg) */
	enc_writebuf2( ETHERTYPE_IP );	/* vvgR(IP) */
	enc_writebuf( PHYSICALADDR_SIZE );	/* n[hEFAAhX(MACAhX) */
	enc_writebuf( IPADDR_SIZE );	/* vgRAhX(IPAhX) */
	enc_writebuf2( ARP_REQUEST );	/* Iy[VR[h(ARPv) */
	enc_writebuffer( mac_address, PHYSICALADDR_SIZE );/* ARPMMACAhX */
	enc_writebuf4( myipaddr );		/* ARPMAhXRs[ */
	enc_fillwrite( 0, PHYSICALADDR_SIZE );	/* ARPMACAhX */
	enc_writebuf4( partadr );	/* ARPMIPAhX */
	enc_writereg16( ETXND, TMPSTART + 42 );	/* Mt[Iʒu */
	enc_setbit( ECON1, ECON1_TXRTS );	/* M */
	while( enc_readethreg( ECON1 ) & ECON1_TXRTS );	/* M҂ */
	enc_writereg16( ETXST, TXSTART );	/* M擪ʒu߂ */
}


/**
*	`qo
*	 in	Ȃ
*	out	Ȃ
*/
static void	arp_reply( arp_st *rxarp )
{
	pacinfo.datasize = ARP_SIZE;
	enc_txseek( ETHERHDR_SIZE );	/* ݊Jnʒu */
	enc_writebuf2( ARP_HWETHER );	/* n[hEFA^Cv(C[Tlbg) */
	enc_writebuf2( ARP_PROTOIP );	/* vvgR(IP) */

	enc_writebuf( PHYSICALADDR_SIZE );/* n[hEFAAhX(MACAhX) */
	enc_writebuf( IPADDR_SIZE );	/* vgRAhX(IPAhX) */
	enc_writebuf2( ARP_REPLY );	/* ARP */
	enc_writebuffer( mac_address, PHYSICALADDR_SIZE );/* `qoMl`bAhX */
	enc_writebuf4( myipaddr );	/* MhoAhX */
	enc_writebuffer( rxarp->srcmac, PHYSICALADDR_SIZE );
					/* `qol`bAhXRs[ */
	enc_writebuffer((byte *)&rxarp->sipaddr, IPADDR_SIZE );
					/* hoAhX͂̂܂܃Rs[ */

	ether_output( ETHERTYPE_ARP );	/* C[Tlbg */
}


/**
*	`qopPbgM
*	{͌Ƀ`FbNׂAROMeʂȂ̂ōŏɂ
*	 in	Ȃ
*	out	Ȃ
*/
void	arp_input( void )
{
	dword	sadr, dadr;
	word	op;
	arp_st	rx_arp;

	enc_readbuffer( (byte *)&rx_arp, ARP_SIZE );
	op = cnvendian16( rx_arp.opcode );	/* OPR[h */
	sadr = cnvendian32( rx_arp.sipaddr );	/* MIPAhX */
	dadr = cnvendian32( rx_arp.dipaddr );	/* IPAhX */
	if( cnvendian16( rx_arp.hwtype ) != 0x0001 ){	/* C[Tlbgł͂Ȃ */
		return;
	}
	else if( cnvendian16( rx_arp.protocol ) != 0x0800 ){	/* IPł͂Ȃ */
		return;
	}
	else if( dadr != myipaddr ){	/* ł͂Ȃ */
		return;
	}
	arp_keep( sadr, rx_arp.srcmac, on );	/* e[uo^ */
	if( op == ARP_REQUEST ){	/* ARPv󂯂 */
		arp_reply( &rx_arp );	/* ARP */
	}
}


/* end of arp.c */
