/**
*	93C46C^[tF[X
*	Copyright (c)Junnichi Tomaru 2002-2008
*/
#include	"avrntp.h"

#define	EEP_CSA()	(PORTD |= 0x10)
#define	EEP_CSN()	(PORTD &= 0xef)
#define	EEP_SKA()	(PORTB |= 0x20)
#define	EEP_SKN()	(PORTB &= 0xdf)
#define	EEP_DI()	(PINB & 0x10)
#define	EEP_DOH()	(PORTB |= 0x08)
#define	EEP_DOL()	(PORTB &= 0xf7)

/**
*	0.5us҂
*	0.5us = (1/12.8M)*7cycle=0.5469us
*	 in:Ȃ
*	out:Ȃ
*/
void	wait05us( void )
{
#if defined( USE_16M )
	__asm__ __volatile__( "nop" );
#endif
	/* 7cycle(RCALL,RET) */
}


/**
*	wAhXPUrbgf[^ǂݏo
*	AhX(ʂUrbgL 00H-3FH)
*	 in	AhX
*	out	PUrbgf[^
*/
word	geteeprom( char addr )
{
	byte	i;
	word	ret;

	_di( );
	EEP_SKA( );	/* CS O SK グĂ */
	EEP_CSA( );	/* CS */
	addr &= 0x3f;	/* AhXʂUrbgL */
	addr |= 0x80;	/* ǂݏoR}h */

	/* Wrbgo(R}ho) */
	EEP_DOH( );	/* X^[grbg */
	EEP_SKN( );	/* SK  */
	wait05us( );
	EEP_SKA( );	/* SK グ */
	for( i = 0; i < 8; i++ ){
		if(( addr & 0x80 ) == 0x80 ){	/* ŏʃrbgcnɃZbg */
			EEP_DOH( );
		}
		else{
			EEP_DOL( );
		}
		addr = addr << 1;
		EEP_SKN( );	/* SK  */
		wait05us( );
		EEP_SKA( );	/* SK オ胉b` */
	}

	ret = 0;
	for( i = 0; i < 16; i++ ){	/* PUrbgf[^ */
		EEP_SKN( );	/* SK  */
		wait05us( );
		EEP_SKA( );	/* SK オm */
		wait05us( );	/* f[^x */
		ret = ret << 1;	/* ܂Vtg */
		if( EEP_DI( ) ){	/* rbgf[^ɓ */
			ret |= 1;
		}
	}
	EEP_CSN( );	/* I */
	_ei( );

	return	ret;
}


/* end of eeprom.c */
