/**
*	ENC28J60`
*	Copyright (c)Junnichi Tomaru 2006
*/

/*	  obt@蓖
*	0000 |------------|
*	     |Mobt@|
*	19D7 |------------|
*	19D8 |------------|
*	     |Mobt@|
*	1FCB |------------|
*	1FCC |------------|
*	     |`qovp|
*	1FFF |------------|
*/
#define RXSTART	0x0000	/* Ԓnɐݒ肷邱 */
#define	RXSTOP	0x19d7
#define RXSIZE	(RXSTOP-RXSTART+1)
#define	TXSTART	0x19d8	/* Ԓnɐݒ肵ǂ */
#define	TXEND	0x1fcb	/* 1524oCg(pPbg1514+Rg[1+Xe[^X8) */
#define	TMPSTART	0x1fcc
#define	TMPEND	0x1fff

#define	RXSTS_SIZE	0x0006
#define	PPCB_SIZE	1	/* Per Packet Control Byte */

/* SPICXgNV(ꕔARGUMENT܂) */
#define	ENC_RCR 	0x00	/* Read Control Resister */
#define	ENC_RBM 	0x3A	/* Read Buffer Memory */
#define	ENC_WCR 	0x40	/* Write Control Resister */
#define	ENC_WBM 	0x7A	/* Write Buffer Memory */
#define	ENC_BFS 	0x80	/* Bit Field Set */
#define	ENC_BFC 	0xa0	/* Bit Field Clear */
#define	ENC_SC	 	0xff	/* System Command */

/* WX^` */

/* y[WO */
#define	ERDPTL		0x00
#define	ERDPTH		0x01
#define	EWRPTL		0x02
#define	EWRPTH		0x03
#define	ETXSTL		0x04
#define	ETXSTH		0x05
#define	ETXNDL		0x06
#define	ETXNDH		0x07
#define	ERXSTL		0x08
#define	ERXSTH		0x09
#define	ERXNDL		0x0a
#define	ERXNDH		0x0b
#define	ERXRDPTL	0x0c
#define	ERXRDPTH	0x0d
#define	ERXWRPTL	0x0e
#define	ERXWRPTH	0x0f
#define	EDMASTL		0x10
#define	EDMASTH		0x11
#define	EDMANDL		0x12
#define	EDMANDH		0x13
#define	EDMADSTL	0x14
#define	EDMADSTH	0x15
#define	EDMACSL		0x16
#define	EDMACSH		0x17

/* y[WO@PUrbg */
#define	ERDPT		0x00
#define	EWRPT		0x02
#define	ETXST		0x04
#define	ETXND		0x06
#define	ERXST		0x08
#define	ERXND		0x0a
#define	ERXRDPT		0x0c
#define	ERXWRPT		0x0e
#define	EDMAST		0x10
#define	EDMAND		0x12
#define	EDMADST		0x14
#define	EDMACS		0x16

/* RWX^ */
#define	EIE		0x1b
#define	EIR		0x1c
#define	ESTAT		0x1d
#define	ECON2		0x1e
#define	ECON1		0x1f

/* y[WP */
#define	EHT0		0x00
#define	EHT1		0x01
#define	EHT2		0x02
#define	EHT3		0x03
#define	EHT4		0x04
#define	EHT5		0x05
#define	EHT6		0x06
#define	EHT7		0x07
#define	EPMM0		0x08
#define	EPMM1		0x09
#define	EPMM2		0x0a
#define	EPMM3		0x0b
#define	EPMM4		0x0c
#define	EPMM5		0x0d
#define	EPMM6		0x0e
#define	EPMM7		0x0f
#define	EPMCSL		0x10
#define	EPMCSH		0x11
#define	EPMOL		0x14
#define	EPMOH		0x15
#define	EWOLIE		0x16
#define	EWOLIR		0x17
#define	ERXFCON		0x18
#define	EPKTCNT		0x19

/* y[WP@PUrbg */
#define	EPMCS		0x10
#define	EPMO		0x14

/* y[WQ */
#define	MACON1		0x00
#define	MACON2		0x01
#define	MACON3		0x02
#define	MACON4		0x03
#define	MABBIPG		0x04
#define	MAIPGL		0x06
#define	MAIPGH		0x07
#define	MACLCON1	0x08
#define	MACLCON2	0x09
#define	MAMXFLL		0x0a
#define	MAMXFLH		0x0b
#define	MAPHSUP		0x0d
#define	MICON		0x11
#define	MICMD		0x12
#define	MIREGADR	0x14
#define	MIWRL		0x16
#define	MIWRH		0x17
#define	MIRDL		0x18
#define	MIRDH		0x19

/* y[WQ@PUrbg */
#define	MAIPG		0x06
#define	MAMXFL		0x0a
#define	MIWR		0x16
#define	MIRD		0x18

/* y[WR */
#define	MAADR1		0x00
#define	MAADR0		0x01
#define	MAADR3		0x02
#define	MAADR2		0x03
#define	MAADR5		0x04
#define	MAADR4		0x05
#define	EBSTSD		0x06
#define	EBSTCON		0x07
#define	EBSTCSL		0x08
#define	EBSTCSH		0x09
#define	MISTAT		0x0a
#define	EREVID		0x12
#define	ECOCON		0x15
#define	EFLOCON		0x17
#define	EPAUSL		0x18
#define	EPAUSH		0x19

/* y[WR@PUrbg */
#define	EBSTCS		0x08
#define	EPAUS		0x18

/* BIST[h */
#define	RACE_MODE	0x0c
#define	PTN_SFT		0x08
#define	ADR_FIL		0x04
#define	RND_FIL		0x00

/* PHY */
#define	PHCON1		0x00
#define	PHSTAT1		0x01
#define	PHID1		0x02
#define	PHID2		0x03
#define	PHCON2		0x10
#define	PHSTAT2		0x11
#define	PHIE		0x12
#define	PHIR		0x13
#define	PHLCON		0x14

/* DUPLEX */
#define	HALF_DUPLEX	0
#define	FULL_DUPLEX	1
#define	LEDB_STATE	2

/* kdcRg[ */
#define	LEDA_TXACT	0x0100
#define	LEDA_RXACT	0x0200
#define	LEDA_COLACT	0x0300
#define	LEDA_LINK	0x0400
#define	LEDA_DUP	0x0500
#define	LEDA_TXRXACT	0x0700
#define	LEDA_ON		0x0800
#define	LEDA_OFF	0x0900
#define	LEDA_BLKFAST	0x0a00
#define	LEDA_BLKSLOW	0x0b00
#define	LEDA_LNKRX	0x0c00
#define	LEDA_LNKTXRX	0x0d00
#define	LEDA_DUPCOL	0x0e00

#define	LEDB_TXACT	0x0010
#define	LEDB_RXACT	0x0020
#define	LEDB_COLACT	0x0030
#define	LEDB_LINK	0x0040
#define	LEDB_DUP	0x0050
#define	LEDB_TXRXACT	0x0070
#define	LEDB_ON		0x0080
#define	LEDB_OFF	0x0090
#define	LEDB_BLKFAST	0x00a0
#define	LEDB_BLKSLOW	0x00b0
#define	LEDB_LNKRX	0x00c0
#define	LEDB_LNKTXRX	0x00d0
#define	LEDB_DUPCOL	0x00e0

/* rbg` */

/* EIE */
#define	EIE_RXERIE	0x01
#define	EIE_TXERIE	0x02
#define	EIE_WOLIE	0x04
#define	EIE_TXIE	0x08
#define	EIE_LINKIE	0x10
#define	EIE_DMAIE	0x20
#define	EIE_PKTIE	0x40
#define	EIE_INTIE	0x80

/* EIR */
#define	EIR_RXERIF	0x01
#define	EIR_TXERIF	0x02
#define	EIR_WOLIF	0x04
#define	EIR_TXIF	0x08
#define	EIR_LINKIF	0x10
#define	EIR_DMAIF	0x20
#define	EIR_PKTIF	0x40

/* ESTAT */
#define	ESTAT_CLKRDY	0x01
#define	ESTAT_TXABRT	0x02
#define	ESTAT_RXBUSY	0x04
#define	ESTAT_LATECOL	0x10
#define	ESTAT_INT	0x80

/* ECON2 */
#define	ECON2_VRPS	0x08
#define	ECON2_VRTP	0x10
#define	ECON2_PWRSV	0x20
#define	ECON2_PKTDEC	0x40
#define	ECON2_AUTOINC	0x80

/* ECON1 */
#define	ECON1_BSEL0	0x01
#define	ECON1_BSEL1	0x02
#define	ECON1_RXEN	0x04
#define	ECON1_TXRTS	0x08
#define	ECON1_CSUMEN	0x10
#define	ECON1_DMAST	0x20
#define	ECON1_RXRST	0x40
#define	ECON1_TXRST	0x80

/* EWOLIE */
#define	EWOLIE_BCWOLIE	0x01
#define	EWOLIE_MCWOLIE	0x02
#define	EWOLIE_HTWOLIE	0x04
#define	EWOLIE_MPWOLIE	0x08
#define	EWOLIE_PMWOLIE	0x10
#define	EWOLIE_AWOLIE	0x40
#define	EWOLIE_UCWOLIE	0x80

/* EWOLIR */
#define	EWOLIR_BCWOLIF	0x01
#define	EWOLIR_MCWOLIF	0x02
#define	EWOLIR_HTWOLIF	0x04
#define	EWOLIR_MPWOLIF	0x08
#define	EWOLIR_PMWOLIF	0x10
#define	EWOLIR_AWOLIF	0x40
#define	EWOLIR_UCWOLIF	0x80

/* ERXFCON */
#define	ERXFCON_BCEN	0x01
#define	ERXFCON_MCEN	0x02
#define	ERXFCON_HTEN	0x04
#define	ERXFCON_MPEN	0x08
#define	ERXFCON_PMEN	0x10
#define	ERXFCON_CRCEN	0x20
#define	ERXFCON_ANDOR	0x40
#define	ERXFCON_UCEN	0x80

/* MACON1 */
#define	MACON1_MARXEN	0x01
#define	MACON1_PASSALL	0x02
#define	MACON1_RXPAUS	0x04
#define	MACON1_TXPAUS	0x08
#define	MACON1_LOOPBK	0x10

/* MACON2 */
#define	MACON2_TFUNRST	0x01
#define	MACON2_MATXRST	0x02
#define	MACON2_RFUNRST	0x04
#define	MACON2_MARXRST	0x08
#define	MACON2_RNDRST	0x40
#define	MACON2_MARST	0x80

/* MACON3 */
#define	MACON3_FULDPX	0x01
#define	MACON3_FRMLNEN	0x02
#define	MACON3_HFRMEN	0x04
#define	MACON3_PHDRLEN	0x08
#define	MACON3_TXCRCEN	0x10
#define	MACON3_PADCFG0	0x20
#define	MACON3_PADCFG1	0x40
#define	MACON3_PADCFG2	0x80

/* MACON4 */
#define	MACON4_PUREPRE	0x01
#define	MACON4_LONGPRE	0x02
#define	MACON4_NOBKOFF	0x10
#define	MACON4_BPEN	0x20
#define	MACON4_DEFER	0x40

/* MAPHSUP */
#define	MAPHSUP_RSTRMII	0x08

/* MICON */
#define	MICON_RSTMII	0x80

/* MICMD */
#define	MICMD_MIIRD	0x01
#define	MICMD_MIISCAN	0x02

/* EBSTCON */
#define	EBSTCON_BISTST	0x01
#define	EBSTCON_TME	0x02
#define	EBSTCON_TMSEL0	0x04
#define	EBSTCON_TMSEL1	0x08
#define	EBSTCON_PSEL	0x10
#define	EBSTCON_PSV0	0x20
#define	EBSTCON_PSV1	0x40
#define	EBSTCON_PSV2	0x80

/* MISTAT */
#define	MISTAT_BUSY	0x01
#define	MISTAT_SCAN	0x02
#define	MISTAT_NVALID	0x04

/* ECOCON */
#define	ECOCON_COCON0	0x01
#define	ECOCON_COCON1	0x02
#define	ECOCON_COCON2	0x04

/* EFLOCON */
#define	EFLOCON_FCEN0	0x01
#define	EFLOCON_FCEN1	0x02
#define	EFLOCON_FULDPXS	0x04

/* PHY */

/* PHCON1 */
#define	PHCON1_PDPXMD	0x0100
#define	PHCON1_PPWRSV	0x0800
#define	PHCON1_PLOOPBK	0x4000
#define	PHCON1_PRST	0x8000

/* PHSTAT1 */
#define	PHSTAT1_JBSTAT	0x0002
#define	PHSTAT1_LLSTAT	0x0004
#define	PHSTAT1_PHDPX	0x0800
#define	PHSTAT1_PFDPX	0x1000

/* PHID2 */
#define	PHID2_PREV0	0x0001
#define	PHID2_PREV1	0x0002
#define	PHID2_PREV2	0x0004
#define	PHID2_PREV3	0x0008
#define	PHID2_PPN0	0x0010
#define	PHID2_PPN1	0x0020
#define	PHID2_PPN2	0x0040
#define	PHID2_PPN3	0x0080
#define	PHID2_PPN4	0x0100
#define	PHID2_PPN5	0x0200
#define	PHID2_PID19	0x0400
#define	PHID2_PID20	0x0800
#define	PHID2_PID21	0x1000
#define	PHID2_PID22	0x2000
#define	PHID2_PID23	0x4000
#define	PHID2_PID24	0x8000

/* PHCON2 */
#define	PHCON2_HDLDIS	0x0100
#define	PHCON2_JABBER	0x0400
#define	PHCON2_TXDIS	0x2000
#define	PHCON2_FRCLNK	0x4000

/* PHSTAT2 */
#define	PHSTAT2_PLRITY	0x0020
#define	PHSTAT2_DPXSTAT	0x0200
#define	PHSTAT2_LSTAT	0x0400
#define	PHSTAT2_COLSTAT	0x0800
#define	PHSTAT2_RXSTAT	0x1000
#define	PHSTAT2_TXSTAT	0x2000

/* PHIE */
#define	PHIE_PGEIE	0x0002
#define	PHIE_PLNKIE	0x0010

/* PHIR */
#define	PHIR_PGIF	0x0004
#define	PHIR_PLNKIF	0x0010

/* PHLCON */
#define	PHLCON_STRCH	0x0002
#define	PHLCON_LFRQ0	0x0004
#define	PHLCON_LFRQ1	0x0008
#define	PHLCON_LBCFG0	0x0010
#define	PHLCON_LBCFG1	0x0020
#define	PHLCON_LBCFG2	0x0040
#define	PHLCON_LBCFG3	0x0080
#define	PHLCON_LACFG0	0x0100
#define	PHLCON_LACFG1	0x0200
#define	PHLCON_LACFG2	0x0400
#define	PHLCON_LACFG3	0x0800


/* end of enc28j60.h */
