/*
*	ethernet.c
*	C[Tlbgw[`(nrhQƃfQw:f[^Nw)
*	Copyright (c)Junnichi Tomaru 2008
*/
#include	"avrntp.h"


/**
*	C[Tlbg͏(C[Tlbgwb_)
*	 in	Ȃ
*	out	1:Ȍ㏈邱Ƃ 0:I
*/
byte	ether_input( void )
{
	struct	ETHER_T{
		byte	destmac[6];	/* l`bAhX */
		byte	srcmac[6];	/* Ml`bAhX */
		word	ethertype;	/* C[Tlbg^Cv */
	} ether_t;
	word	type;
	byte	ret;

	if( enc_input( (byte *)&ether_t ) == 0 ){	/* ͖ */
		return	0;
	}

	memcpy((byte *)pacinfo.mac, (byte *)ether_t.srcmac, PHYSICALADDR_SIZE );
	type = cnvendian16( ether_t.ethertype );	/* vgR^Cv */
	ret = 0;
	if( type == ETHERTYPE_IP ){	/* hovgR */
		ret = 1;
	}
	else if( type == ETHERTYPE_ARP ){	/* ARPvgR */
		arp_input( );
		enc_setnextpoint( );	/* I */
	}
	else{				/* ֌WȂvgR */
		enc_setnextpoint( );
	}

	return	ret;
}


/**
*	C[Tlbgo͏(wb_̃Zbg)
*	 in	point:Mf[^Jnʒu
*		 type:C[Tlbg^Cv
*	out	Ȃ
*/
void	ether_output( word type )
{
	pacinfo.datasize += ETHERHDR_SIZE;
	enc_txseek( ETHER_TOP );
	enc_writebuffer( pacinfo.mac, PHYSICALADDR_SIZE );	/* l`bAhXRs[ */
	enc_writebuffer( mac_address, PHYSICALADDR_SIZE );	/* MMACAhX̃Rs[ */
	enc_writebuf2( type );		/* C[Tlbg vgR^Cv */
	enc_output( );
}


/* end of ethernet.c */
