/**
*	udp.c
*	tcow(gX|[gw(RFC768))
*	User Datagram Protocol:hoAvP[VŒڎg悤ɂvgR
*	Copyright (c)Junnichi Tomaru 2008
*/
#include	"avrntp.h"


/**
*	tcow͏
*	 in	Ȃ
*	out	Ȃ
*/
void	udp_input( void )
{
	word	size, pnt, port;
	udp_st	rxudp;

	enc_readbuffer((byte *)&rxudp, UDPHDR_SIZE );	/* wb_ǂݍ */
	pacinfo.partport = cnvendian16( rxudp.srcport );	/* |[gԍQbg */
	pacinfo.myport = cnvendian16( rxudp.destport );
	size = cnvendian16( rxudp.length );		/* tco */
	pacinfo.proto_len = size - UDPHDR_SIZE;

	pnt = ip_hdrlen + IP_TOP;	/* tcoʒu */
	if( rxudp.chksum != 0 ){	/* `FbN */
		pseudo_hdr.sipaddr = cnvendian32( pacinfo.partipaddr );	/* MhoAhX */
		pseudo_hdr.dipaddr = cnvendian32( pacinfo.myipaddr );	/* hoAhX */
		pseudo_hdr.zero = 0;			/* pfBO(0) */
		pseudo_hdr.protocol = IPPROTO_UDP;	/* vgR */
		pseudo_hdr.paclen = rxudp.length;	/* vgR */
		if( tcpudp_sum( RX, pnt, size ) != 0 ){	/* `FbNTȂ */
			return;
		}
	}
	pacinfo.proto_body = pnt + UDPHDR_SIZE;	/* f[^ʒu */
	port = pacinfo.myport;
	if( port == UDP_NTP ){		/* NTP */
		ntp_input( );
	}
	else if( port == UDP_NBNS ){	/* NetBIOS Name Service */
		nbns_input( );
	}
}


/**
*	tcowo͏
*	 in	f[^
*	out	Ȃ
*/
void	udp_output( word len )
{
	word	sum;

	/* 炩߃f[^ZbgĂ */
	pacinfo.datasize = UDPHDR_SIZE + len;
	enc_txseek( UDP_TOP );
	enc_writebuf2( pacinfo.myport );	/* M|[g */
	enc_writebuf2( pacinfo.partport );	/* |[g */
	enc_writebuf2( pacinfo.datasize );	/* pPbg */
	enc_writebuf2( 0 );			/* `FbNT(vZp) */
	/* `FbNTvZ */
	pseudo_hdr.sipaddr = cnvendian32( myipaddr );
	pseudo_hdr.dipaddr = cnvendian32( pacinfo.partipaddr );
	pseudo_hdr.zero = 0;
	pseudo_hdr.protocol = IPPROTO_UDP;
	pseudo_hdr.paclen = cnvendian16( pacinfo.datasize );
	sum = tcpudp_sum( TX, UDP_TOP, pacinfo.datasize );	/* `FbNTvZ */
	if( sum == 0 ){
		sum = 0xffff;
	}
	enc_txseek( UDP_SUM );		/* `FbNTʒu */
	enc_writebuf2( sum );

	ip_output( IPPROTO_UDP );
}


/* end of udp.c */
