/**
*	ut.h
*	Tu[`W		wb_
*	Copyright (c)Junnichi Tomaru 2006
*/
#ifndef	_UTIL_DEFINED
#define	_UTIL_DEFINED

#include	"userdef.h"
#include	"stime.h"

union DWORD_T{		/* RQPU~Q */
	dword	data;
	struct{		/* gGfBA */
		word	lo;
		word	hi;
	} words;
};
typedef union DWORD_T dword_t;

union	UL_T {		/* RQW~S */
	dword	data;
	struct {	/* gGfBAp */
		byte	ll;
		byte	lh;
		byte	hl;
		byte	hh;
	} bytes;
};
typedef union UL_T	ul_t;

union	UI_T{		/* PUW~Q */
	word	data;
	struct {	/* gGfBAp */
		byte	lo;
		byte	hi;
	} bytes;
};
typedef union UI_T	ui_t;

union NBL_T{
	byte	data;
	struct{
		byte	lo : 4;
		byte	hi : 4;
	} nbl;
};
typedef union NBL_T	nbl_t;

char	*uctoahz( byte num, char *buf );
char	*uctoaz( byte num, char *buf );
char	*utoaz( word num, char *buf );
int	_atoi( char *buf );
word	cnvendian16( word data );
dword	cnvendian32( dword data );
char	*long2ipstr( dword ipadr, char *buf );
void	jst2utc( struct tm *jst, struct tm *utc );
void	utc2jst( struct tm *utc, struct tm *jst );

#endif

/* end of ut.h */
