/**
*	AVRŊȈSNTPT[o
*	Copyright (c)Junnichi Tomaru 2006
*/
#define	_GLOBAL_DEFINED
#include	"avrntp.h"

extern volatile word	counter;
extern volatile byte	arpcnt;

#define	SYNC	bit_is_clear(PIND,PIND2)	/* M */
#define	CLKEN	bit_is_clear(PINB,PINB7)	/* dgvDTRON */

/* 萔֌W */
const prog_char	wday[] = { "SUN\0MON\0TUE\0WED\0THU\0FRI\0SAT" };
const struct tm	st = { 0, 0, 9, 1, 0, 70, 4, 0, 0 };	/* l */
const prog_char	testmac[] = { 0x00, 0x50, 0xC2, 0x96, 0x00, 0x02 };/* eXgp */


/**
*	EEPROMAhXo
*	 in	addr: AhXi[Ԓn
*		 fix: ftHgl
*	out	AhX
*/
static dword	geteepaddr( char addr, dword fix )
{
	dword_t	ret;

	ret.words.lo = geteeprom( addr );
	ret.words.hi = geteeprom( addr + 1 );
	if( ret.data == 0xffffffff ){
		ret.data = fix;
	}

	return	ret.data;
}


/**
*	l̏
*	lKvȕϐ
*	 in	Ȃ
*	out	Ȃ
*/
static void	valinit( void )
{
	ui_t	t;
	char	i, j;

	memset((arp_tb *)&arp_cache, 0, sizeof( arp_cache ));
	memset((char *)keybuf, 0, sizeof( keybuf ));
	memset((char *)nbns_name, 0, sizeof( nbns_name ));
	memset((char *)&time_tm, 0, sizeof( time_tm ));
	keypnt = 0;
	arpcnt = 0;
	cal_day = 0;
	cal_hour = 0;
	cal_min = 0;
	cal_sec = 0;
	time = 0L;
	counter = 0U;
	ip_identifer = 0U;
	interval = 0U;
	timer = 0U;
	timeen = TIME_UNADJUSTED;
	timeflg = adjust = off;
	nowrxpnt = nextrxpnt = RXSTART;	/* Mobt@l */
	jst_time = old_time = st;	/* l */
	myipaddr = geteepaddr( EEP_IPADDR, IPADDR );	/* IPAhXݒ */
	netmask = geteepaddr( EEP_NETMASK, NETMASK );	/* lbg}XNݒ */
	gateway = geteepaddr( EEP_GATEWAY, GATEWAY );	/* ftHgQ[gEFCݒ */
	if( geteeprom( HOST_NAME ) == 0xffff ){	/* ݒ肳ĂȂ */
		strcpy_P( nbns_name, PSTR( "AVR-SNTPSERVER " ));
	}
	else{
		for( i = j = 0; i < 8; i++ ){	/* NetBIOS擾 */
			t.data = geteeprom( HOST_NAME + i );
			nbns_name[j] = t.bytes.lo;
			j++;
			nbns_name[j] = t.bytes.hi;
			j++;
		}
	}
}


/**
*	|[g
*	 in	Ȃ
*	out	Ȃ
*	DDx 0: 1:o
*/
static void	init( void )
{
	ui_t	t;
	char	i, adr;
	byte	*p;

	PRR = 0x89;		/* TMR0,TMR2,SPI,USART */
	PORTB = 0x06;		/* SS=H,LED=off */
	PORTC = 0x00;
	PORTD = 0x02;		/* E='L', TxD='H' */
	DDRB = 0x2e;		/* 0,4,6,7 IN */
	DDRC = 0x00;		/* tڑ̂߈xINɂ */
	DDRD = 0x1a;		/* 1,3,4 OUT */

	lcden = (( PINC & 0x3f ) == 0x3f )? on: off;	/* RS,R/W,D*='H'? */
	DDRC = 0x3f;		/* 6,7 IN */

	if( geteeprom( MACADDRESS ) == 0xffff ){	/* MACAhXĂȂ */
		memcpy_P( mac_address, testmac, PHYSICALADDR_SIZE );
	}
	else{
		/* SPILɂOɁAEEPROMǂݏo */
		adr = MACADDRESS;
		p = mac_address;
		for( i = 0; i < 3; i++, adr++ ){
			t.data = geteeprom( adr );	/* MACAhX擾 */
			*p = t.bytes.lo;
			p++;
			*p = t.bytes.hi;
			p++;
		}
	}

	valinit( );

	SPCR = 0x50;		/* SPIA}X^A2ɐݒ*/
	SPSR = 0x1;		/* X2 */

	UBRR0 = BAUD;		/* 9600bps */
	UCSR0C = 0x6;		/* 8bit,stop1,Pn */
	UCSR0B = 0x18;		/* RxEN,TxEN */

	TCCR0A = 0x02;		/* CTC *//* vp */
	TCCR0B = 0x03;		/* f/64 */
	OCR0A = TIMER0;		/*  */
	TIMSK0 = 0x2;		/* Av荞 */

	TCCR2A = 0x02;		/* CTC *//* ̑p */
	TCCR2B = 0x07;		/* f/1024 */
	OCR2A = TIMER2;		/*  */
	TIMSK2 = 0x2;		/* Av荞 */

	wdt_enable( WDTO_60MS );/* WDTL */
	_ei( );
}


/**
*	ԕ\
*	 in	0:JST 1:UTC
*	out	Ȃ
*/
void	disptime( char dsp )
{
	char	sts, buf[16];
	struct tm	t;

	if( dsp == 0 ){
		t = jst_time;
		lcdprintc( 10, 1, PSTR( "JST" ));
	}
	else if( dsp == 1 ){
		t = utc_time;
		lcdprintc( 10, 1, PSTR( "UTC" ));
	}
	else{
		return;
	}
	t.tm_year += 1900U;
	t.tm_mon++;
	utoaz( t.tm_year, buf );	/* N */
	lcdprint( 0, 0, buf + 1 );
	lcdputch( '/' );
	uctoaz( t.tm_mon, buf );	/*  */
	lcdputstr( buf + 1 );
	lcdputch( '/' );
	uctoaz( t.tm_mday, buf );	/*  */
	lcdputstr( buf + 1 );
	lcdprintc( 11, 0, &wday[t.tm_wday*4] );	/* j */
	lcdputcode( 15, 0, interval + '0' );	/* Ԋu */
	uctoaz( t.tm_hour, buf );	/*  */
	lcdprint( 1, 1, buf + 1 );
	lcdputch( ':' );
	uctoaz( t.tm_min, buf );	/*  */
	lcdputstr( buf + 1 );
	lcdputch( ':' );
	uctoaz( t.tm_sec, buf );	/* b */
	lcdputstr( buf + 1 );
	sts = ( adjust == on )? 'C': 'N';
	lcdputcode( 14, 1, sts );	/* Z */
	if( timeen == TIME_UNADJUSTED ){
		sts = 'U';
	}
	else if( timeen == TIME_ILLEGAL ){
		sts = 'I';
	}
	else{
		sts = 'A';
	}
	lcdputch( sts );	/*  */
}


/**
*	ʏ
*	 in	[h
*		0,1: 2:IP&MASK 3:GATE&MAC 4:VER&REV,Interval
*	out	Ȃ
*/
static void	redraw( char mode )
{
	char	c, i, j, buf[16];
	byte	*p;

	lcdcls( );
	if( mode == 2 ){
		long2ipstr( myipaddr, buf );	/* IPAhX\ */
		lcdprint( 0, 0, buf );
		long2ipstr( netmask, buf );	/* lbg}XN */
		lcdprint( 0, 1, buf );
	}
	else if( mode == 3 ){
		long2ipstr( gateway, buf );	/* Q[gEFC */
		lcdprint( 0, 0, buf );
		lcdprintc( 0, 1, PSTR( "MAC:" ));	/* MACAhX\ */
		p = mac_address;
		for( i = 0, j = 4; i < 6; i++, j+=2, p++ ){
			lcdprint( j, 1, uctoahz( *p, buf ));
		}
	}
	else if( mode == 4 ){
		lcdprintc( 0, 0, PSTR( "Firmware:" ));
		lcdprintc( 9, 0, PSTR( VERSION ));
		lcdprintc( 0, 1, PSTR( "ENC28J60 REV:" ));
		enc_bankselect( 3 );
		c = enc_readethreg( EREVID ) & 0x1f;	/* REVID */
		lcdputch(( c / 10 ) + '0' );
		lcdputch(( c % 10 ) + '0' );
	}
	else if( mode == 5 ){
		lcdprintc( 0, 0, PSTR( "Last Update Time" ));
		lcdputcode( 0, 1, ' ' );
		uctoaz( cal_mon, buf );
		lcdputstr( buf + 1 );
		lcdputch( '/' );
		uctoaz( cal_day, buf );
		lcdputstr( buf + 1 );
		lcdputch( ' ' );
		uctoaz( cal_hour, buf );
		lcdputstr( buf + 1 );
		lcdputch( ':' );
		uctoaz( cal_min, buf );
		lcdputstr( buf + 1 );
		lcdputch( ':' );
		uctoaz( cal_sec, buf );
		lcdputstr( buf + 1 );
	}
	else{
		disptime( mode );
	}
}


/**
*	Xe[^X擾
*	MFSTUS
*	ԐMFYES or No
*/
swbool	getsts( void )
{
	char	buffer[16];
	swbool	ret;

	setsiostr( "STUS" );
	getsiostr( buffer );
	buffer[8] = '\0';
	if( strcmp_P( buffer, PSTR( "adjusted" )) == 0 ){
		ret = on;
	}
	else{
		ret = off;
	}

	return	ret;
}


/**
*	t킹
*	MFDATE
*	ԐMFYYYY/MM/DD
*/
static void	getdate( struct tm *t )
{
	char	buffer[20];

	setsiostr( "DATE" );
	getsiostr( buffer );
	t->tm_year = _atoi( buffer );		/* N */
	t->tm_mon = _atoi( buffer + 5 );	/*  */
	t->tm_mday = _atoi( buffer + 8 );	/*  */
}


/**
*	킹
*	MFSTIM
*	ԐMFHH:MM:SS
*/
static void	gettime( struct tm *t )
{
	char	buffer[16];

	setsiostr( "STIM" );
	getsiostr( buffer );
	t->tm_hour = _atoi( buffer );
	t->tm_min = _atoi( buffer + 3 );
	t->tm_sec = _atoi( buffer + 6 );
}


/**
*	dgv莞𓾂
*	 in	Ȃ
*	out	Xe[^X
*/
char	getnowtime( void )
{
	time_t	utccnt, oldutc;
	struct tm	tmp;
	char	ret;

	getdate( &tmp );	/* t擾 */
	gettime( &tmp );	/* 擾 */
	/* < 2000`FbN͍폜(Ōoł̂) */
	jst_time = tmp;
	jst_time.tm_year -= 1900U;
	jst_time.tm_mon--;
	jst2utc( &jst_time, &utc_time );	/* JST->UTC */
	oldutc = time;		/* T[o[̎ */
	utccnt = mktime( &utc_time );	/* UTC -> sec(1970.1.1`) */
	if( utccnt >= 0 ){
		if( timeen != TIME_UNADJUSTED ){	/* `FbN */
			if( utccnt <= ( oldutc - TIME_WIDTH )){
				return TIME_ILLEGAL; /* }CiXɈ莞Ԉȏ */
			}
			else if( utccnt >= ( oldutc + TIME_WIDTH )){
				return TIME_ILLEGAL; /* vXɈ莞Ԉȏ */
			}
		}
		_di( );
		time = utccnt;
		timer = 0;	/* ^C}Zbg */
		timeflg = on;
		rnstamp = utccnt;
		rntime = 0;
		_ei( );
		cal_mon = tmp.tm_mon;
		cal_day = tmp.tm_mday;
		cal_hour = tmp.tm_hour;
		cal_min = tmp.tm_min;
		cal_sec = tmp.tm_sec;
		ret = TIME_ADJUSTED;
	}
	else{
		ret = TIME_ILLEGAL;
	}

	return	ret;
}


/**
*	`FbNԊuύX
*	͈͂1,3,10,30,60,180,360(min)
*	 in	Ȃ
*	out	Ȃ
*/
static void	change_interval( void )
{
	int	val;

	val = interval;
	if( timeen == TIME_ADJUSTED ){	/* ␳ */
		val++;
		if( val >= 6 ){
			val = 5;	/* ő3h(180min) */
		}
	}
	else{	/* ␳s */
		val--;
		if( val < 0 ){
			val = 0;	/* ŏ1min */
		}
	}
	interval = val;
}


/**
*	̍߂(P)
*	 in	s:Jn
*		e:I
*	out	(b)
*/
static word	rtc_sub( struct tm *s, struct tm *e )
{
	int	em, eh;
	int	sm, sh;

	em = e->tm_min;
	eh = e->tm_hour;
	sm = s->tm_min;
	sh = s->tm_hour;

	em -= sm;	/*  */
	if( em < 0 ){
		em += 60U;
		eh--;
	}
	eh -= sh;	/*  */
	if( eh < 0 ){	/* ȏ߂邱ƂȂ */
		eh += 24U;
	}
	return	( eh * 60U + em );
}


/**
*	ԃ`FbN
*	 in	Ȃ
*	out	Ȃ
*/
static void	checksync( void )
{
	const	int	intbl[] = { 1U, 3U, 10U, 30U, 60U, 180U };
	static swbool	flg;

	if( jst_time.tm_sec != 0 ){	/* xȊO͏Ȃ */
		flg = off;
		return;
	}
	if( rtc_sub( &old_time, &jst_time ) < intbl[interval] ){/* ␳ */
		return;
	}
	if( flg == on ){	/* IĂ̂ */
		return;
	}
	if( CLKEN ){		/* dgvL */
		adjust = getsts( );
		if( adjust == on ){	/* Z */
			timeen = getnowtime( );	/* Ď擾 */
		}
		else{
			timeen = TIME_UNADJUSTED;/* A𑁂߂邽 */
		}
		change_interval( );
		flg = on;
	}
	old_time = jst_time;	/* ̂߂ */
}


/**
*	L[
*	 in	ŐV̕\
*	out	XVꂽ\
*/
static char	keyseq( char dsp )
{
	char	key;
	static char	odsp;

	key = keysense( );
	if( key != 0 ){	/* L[ω */
		if( lcden == on ){
			if( key == ENTER_KEY ){	/* 蓮Zbg */
				settime( );
				lcdcls( );
				timeflg = on;	/* ̂ */
				dsp = 0;
			}
			else if( key == UP_KEY ){
				dsp++;
				if( dsp > 4 ){
					dsp = 0;
				}
			}
			else if( key == DOWN_KEY ){
				if( dsp == 0 ){
					dsp = 4;
				}
				else{
					dsp--;
				}
			}
			else if( key == RIGHT_KEY ){
				dsp = 5;
			}
			else if( key == LCDDI_KEY ){
				lcdcls( );
				lcdprintc( 0, 0, PSTR( "LCD Disabled." ));
				lcden = off;
			}
		}
		else if( key == LCDEN_KEY ){
			lcdinit( );
			lcden = on;
			dsp = 0;
		}
		if( odsp != dsp ){	/* ʕύX */
			odsp = dsp;
			redraw( dsp );
		}
	}

	return	dsp;
}


/**
*	C
*	 in	Ȃ
*	out	Ȃ
*/
int	main( void )
{
	byte	flg;
	char	dsp;
	struct tm	*dspt;
	time_t	utccnt;

	dsp = 0;
	_di( );
	init( );
	enc_init( );	/* ENC28J60 */
	if( lcden ){
		lcdinit( );
	}
	disptime( 0 );	/* \ */
	while( 1 ){
		wdt_reset( );		/* WDT̍XV */
		flg = ip_input( );	/* |[Op */
		if( flg == 1 ){		/* ICMPM */
			icmp_input( );
			enc_setnextpoint( );
		}
		else if( flg == 2 ){	/* UDPM */
			udp_input( );
			enc_setnextpoint( );
		}
		if( SYNC && CLKEN ){	/* M */
			adjust = getsts( );
			if( adjust == on ){	/* Z󋵎擾 */
				timeen = TIME_UNADJUSTED;/* `FbNȂ悤 */
				timeen = getnowtime( );
				interval = 0;	/* {^ΉȂƂƂ */
			}
		}
		else{
			dsp = keyseq( dsp );	/* L[ */
		}
		if( timeflg == on ){	/* XVꂽ */
			_di( );
			utccnt = time;
			timeflg = off;
			_ei( );
			dspt = gmtime( &utccnt );	/* COUNT->UTC */
			if( dspt != NULL ){
				utc_time = *dspt;
				utc2jst( &utc_time, &jst_time );/* UTC->JST */
				if( lcden == on ){
					disptime( dsp );
				}
				checksync( );	/* Zԃ`FbN */
			}
			if( timeen == TIME_ADJUSTED ){	/* mFLED */
				PORTB &= 0xfd;
			}
			else{
				PORTB |= 0x02;
			}
		}
	}

	return	0;
}


/* end of avrntp.c */
