/**
*	how(nrhQƃfRwFlbg[Nw  RFC791,RFC919,RFC922)
*	Internet Protocol:oĤ߂̃AhX\pPbg̕Eč\Ȃ
*	Copyright (c)2005 Junnichi Tomaru
*/
#include	"avrntp.h"


/**
*	how͏
*	 in	Ȃ
*	out	0:ȍ~̏Ȃ ȊO:
*/
byte	ip_input( void )
{
	byte	ret, i, opt, flg;
	dword	dip, bld;
	ip_st	rxip;

	if( ether_input( ) == 0 ){	/* C[Tlbgw */
		return	0;
	}
	if( enc_rxchksum( IP_TOP, IPHDR_SIZE ) != 0 ){	/* `FbNTȂ */
		enc_setnextpoint( );
		return	0;
	}
	enc_rxseek( IP_TOP );
	enc_readbuffer((byte *)&rxip, IPHDR_SIZE );/* IPwb_ǂݍ */
	dip = cnvendian32( rxip.dipaddr );
	bld = dip | netmask;
	if(( rxip.ipver & 0xf0 ) != 0x40 ){	/* IPv4ǂ̃`FbN */
		enc_setnextpoint( );
		return	0;
	}
	flg = ret = 0;
	if( dip == myipaddr ){		/* H */
		flg = 1;
	}
	else if( bld == IP_BROADCAST ){	/* lbg[Nu[hLXg */
		flg = 1;
	}
	else if( dip == IP_BROADCAST ){	/* u[hLXg */
		flg = 1;
	}
	if( flg ){
		ip_hdrlen = ( rxip.ipver & 0xf ) * 4;
		pacinfo.datasize = cnvendian16( rxip.length );	/* IPpPbg */
		pacinfo.datasize -= ip_hdrlen;	/* wb_ */
		pacinfo.partipaddr = cnvendian32( rxip.sipaddr );
		pacinfo.myipaddr = dip;
		if( ip_hdrlen > IPHDR_SIZE ){	/* IvV */
			opt = ip_hdrlen - IPHDR_SIZE;
			for( i = 0; i < opt; i++ ){	/* ǂݔ΂ */
				enc_readbuf( );
			}
		}
		arp_keep( pacinfo.partipaddr, pacinfo.mac, off );	/* ARPLbVo^ */
		if( rxip.protocol == IPPROTO_ICMP ){
			ret = 1;
		}
		else if( rxip.protocol == IPPROTO_UDP ){
			ret = 2;
		}
		else{
			enc_setnextpoint( );
			ret = 0;
		}
	}
	else{
		enc_setnextpoint( );
	}

	return	ret;
}


/**
*	howo͏
*	 in	protocol:ʃvgR
*	out	0:I@1:ARP^CAEg
*/
byte	ip_output( byte protocol )
{
	word	sum, wait_timer;
	byte	sts;

	pacinfo.datasize += IPHDR_SIZE;	/* IPwb_ */
	enc_txseek( IP_TOP );		/* ݊Jnʒu */
	enc_writebuf( 0x45 );		/* IPv4wb_(20oCg) */
	enc_writebuf( 0x00 );		/* TOS */
	enc_writebuf2( pacinfo.datasize );	/* S̒ */
	enc_writebuf2( ip_identifer );	/* ʎq */
	enc_writebuf( 0x40 );		/* tO,ItZbg:s\ */
	enc_writebuf( 0x00 );
	enc_writebuf( 0x40 );		/*  */
	enc_writebuf( protocol );	/* vgR */
	enc_writebuf( 0 );		/* vZpȂ̂łO */
	enc_writebuf( 0 );
	enc_writebuf4( myipaddr );	/* Mho */
	enc_writebuf4( pacinfo.partipaddr );/* ho */
	sum = enc_txchksum( ETHERHDR_SIZE, IPHDR_SIZE );/* wb_`FbNTvZ */
	enc_txseek( IP_SUM );		/* `FbNTʒu */
	enc_writebuf2( sum );

	sts = arp_search( );	/* ARPe[u */
	if( sts != 0 ){			/* e[uɓo^ */
		if( sts == 2 ){		/* Q[gEFĈl`bv */
			arp_request( gateway );
		}
		else{
			arp_request( pacinfo.partipaddr );	/* `qovo */
		}
		/* wait_arpreply( ) `qovɑ΂鉞҂ */
		enc_setnextpoint( );
		wait_timer = getcount1ms( );
		while( 1 ){		/* ARP҂ */
			ip_input( );	/* ԂĂƂO */
			if( arp_search( ) == 0 ){	/*  */
				break;
			}
			if(( getcount1ms( ) - wait_timer ) >= 1000U ){/* ^C}؂(1b) */
				return 1;
			}
		}
	}
	ether_output( ETHERTYPE_IP );	/* C[Tlbgw */
	ip_identifer++;

	return	0;
}


/**
*	sboтtcõ`FbNTvZ
*	 in	   dir:
*		offset:ItZbg
*		  size:vZ̈TCY
*	out	vZ
*/
word	tcpudp_sum( char dir, word offset, word size )
{
	byte	i, *p;
	ui_t	t;
	dword	ret;

	ret = 0;
	p = (byte *)&pseudo_hdr;	/* [wb_𑫂 */
	for( i = 0; i < 6; i++ ){	/* QoCgZ */
		t.bytes.hi = *p;
		p++;
		t.bytes.lo = *p;
		p++;
		ret += t.data;
		if( ret >= 0x10000 ){	/* I[o[ */
			ret &= 0xffff;
			ret++;		/* L𑫂 */
		}
	}
	if( dir == TX ){
		ret += ~enc_txchksum( offset, size );	/* obt@̉Z */
					/* ߂͂P̕␔Ȃ̂Ŕ]Ė߂ */
	}
	else{
		ret += ~enc_rxchksum( offset, size );	/* obt@̉Z */
					/* ߂͂P̕␔Ȃ̂Ŕ]Ė߂ */
	}
	if( ret >= 0x10000 ){	/* I[o[ */
		ret &= 0xffff;
		ret++;		/* L𑫂 */
	}

	return	(word)( ~ret );	/* `FbNT */
}


/* end of ip.c */
